#include <vcl.h>
#pragma hdrstop

#include <dos.h>
#include <time.h>
#include "bpm1.h"

  clock_t start=0;     //var tempo
  clock_t start2;
  clock_t end;
  float average[10];   //bpm medio
  float diff=1;        //intervallo tempo
  float bpm=0;         //bpm
  float media=0;       //bpm medio
  int multi=1;         //multiplier
  int c=0;
  int i=0;
  int temp;
  int var;
  AnsiString version="1.5";
  AnsiString build="0.0";
  AnsiString build_date="02/09/2011";
  void reset();           //funzione reset
  void help();            //funzione help
  void about();           //funzione about
  float mean();

//========================================================================

#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;

//################## FUNZIONI ##############################################

void reset()
{
//manca recupero informazioni versione file
  Form1->label_build->Caption="v. " + version +"."+ build;
  Form1->Caption="BPM Counter " + version;
  Form1->GroupBox1->Caption=" BPM Counter ";
  Form1->out_media->Caption="0,00";
  //Form1->radiogrp->ItemIndex=0;
  multi=1;
  diff=1;
  bpm=0;
  media=0;
  start=0;
  for (int handle=0; handle<10; handle++) //inizializz. array a 0
    average[handle]=0;
    Form1->ProgressBar->Position=0;
}

void about()
{
    ShowMessage("BPM Counter " + version + build + " by JaKe \n"
    "               " + build_date + " \n"
    "       http://www.jake-afc.net\n\n"
    "      This program is freeware\n"
    "  If you paid for it you've been fooled!\n"
    "  Made in Borland C++ Builder");
}

void help()
{
   ShowMessage (
   "With this program you can calculate the BPM of a track\n"
   "you're listening to. To do that, simply tap BEAT button\n"
   "(or Enter key) following track rhythm for some times.\n"
   "BPM shown is an average of last 10 beats\n"
   "AVG Bar will show when 10th reading has been achieved.\n\n"
   "TIPS: To have a good measure let the program read almost\n"
   "10 beats. For more precision tap tempo  at 1/2 or 1/4 speed\n"
   "then apply the muliplier.");
}


float mean(float *array, int size)
{
        float avg=0;
        for (int handle=0; handle < size; handle++)
                avg=avg+array[handle];
        avg=avg/size;
  return avg;
}
//################## FORM ##################################################
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        reset();
}

//################## CALCOLO BPM ###########################################
void __fastcall TForm1::Button1Click(TObject *Sender)
{

    end=clock();
    start2=start;
    start=clock();
    diff =((end-start2)/CLK_TCK)*1000;
    if(start2 != 0)
    {
        if(i==3)                         //se l'array  pieno, cicla
          i=0;
        if(bpm!=0)
          bpm=(bpm+(1000/diff)*60)/2;
        else
          bpm=(1000/diff)*60;

        average[i]=bpm;                 //lo caccia nell'array
        for(c=0; c<4; c++)             //rimpiazza gli 0 con il primo valore
        {
          if(average[c]==0)
            average[c]=bpm;
        }
        media=mean(average, 4);        //questa funzione dovrebbe essere nell'unit math
        out_media->Caption=media*multi;
        i=i+1;
    }
    ProgressBar->StepIt();
}

//################## MULTIPLIER #############################################
void __fastcall TForm1::RefreshClick(TObject *Sender)
{
float temp_b;
float temp_m;
 if(radiogrp->ItemIndex==0)
 {
   temp_b=bpm;
   temp_m=media;
   multi=1;
 }

 if(radiogrp->ItemIndex==1)
 {
   temp_b=bpm*2;
   temp_m=media*2;
   multi=2;
 }
 if(radiogrp->ItemIndex==2)
 {
   temp_b=bpm*4;
   temp_m=media*4;
   multi=4;
 }
 out_media->Caption=temp_m;
}

//################## TIMER ######################################
void __fastcall TForm1::TimerTimer(TObject *Sender)
{

   if((temp%2)== 0)
   {
   if (var<80)
    var=var+20;
   else
    var=20;
   ProgressBar->Position=var;
   }
   temp=temp+1;

    end=clock();
    start2=start;
    start=clock();
    diff =((end-start2)/CLK_TCK)*2000;    //deve farlo ogni 2
    if(start2 != 0)
    {
        if(i==9)
          i=0;
        if(bpm!=0)
          bpm=(bpm+(1000/diff)*60)/2;
        else
          bpm=(1000/diff)*60;

        average[i]=bpm;
        for(c=0; c<10; c++)
        {
          if(average[c]==0)
            average[c]=bpm;
        }
        media=mean(average, 10);
        i=i+1;
    }

}

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Close();
}

void __fastcall TForm1::About1Click(TObject *Sender)
{
  about();
}

void __fastcall TForm1::HowTo1Click(TObject *Sender)
{
  help();
}

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
   Close();
}

void __fastcall TForm1::Reset1Click(TObject *Sender)
{
  reset();
}

void __fastcall TForm1::b_resetClick(TObject *Sender)
{
  reset();
  Form1->Button1->SetFocus();
}

void __fastcall TForm1::About2Click(TObject *Sender)
{
  about();
}

void __fastcall TForm1::Reset2Click(TObject *Sender)
{
  reset();
}

void __fastcall TForm1::PophelpClick(TObject *Sender)
{
  help();
}

void __fastcall TForm1::Exit3Click(TObject *Sender)
{
  Close();
}

void __fastcall TForm1::Image1Click(TObject *Sender)
{
  about();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::GroupBox1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Form1->Button1->SetFocus();
}
//---------------------------------------------------------------------------

